diff --git a/tests/admin_pages/test_user.py b/tests/admin_pages/test_user.py
index d92508d6..efc4f85d 100644
--- a/tests/admin_pages/test_user.py
+++ b/tests/admin_pages/test_user.py
@@ -159,7 +159,7 @@ def test_users_edit_edit_account(pub):
 
 
 def test_users_edit_with_managing_idp(pub):
-    create_role()
+    create_role(pub)
     pub.user_class.wipe()
     pub.cfg['sp'] = {'idp-manage-user-attributes': True}
     pub.write_cfg()
@@ -261,7 +261,7 @@ def test_users_filter(pub):
     pub.user_class.wipe()
     PasswordAccount.wipe()
     create_superuser(pub)
-    role = create_role()
+    role = create_role(pub)
     for i in range(50):
         user = pub.user_class(name='foo bar %s' % (i + 1))
         user.store()
@@ -346,7 +346,7 @@ def test_users_display_roles(pub):
     pub.user_class.wipe()
 
     user = create_superuser(pub)
-    role = create_role()
+    role = create_role(pub)
     user.roles = [role.id, 'XXX']
     user.store()
 
diff --git a/tests/admin_pages/test_workflow.py b/tests/admin_pages/test_workflow.py
index a4157930..948f8915 100644
--- a/tests/admin_pages/test_workflow.py
+++ b/tests/admin_pages/test_workflow.py
@@ -15,7 +15,6 @@ from webtest import Upload
 
 from wcs.qommon.http_request import HTTPRequest
 from wcs.qommon.errors import ConnectionError
-from wcs.roles import Role
 from wcs.workflows import (
     Workflow,
     WorkflowCriticalityLevel,
@@ -25,6 +24,7 @@ from wcs.workflows import (
     ChoiceWorkflowStatusItem,
     JumpOnSubmitWorkflowStatusItem,
     WorkflowVariablesFieldsFormDef,
+    item_classes,
 )
 from wcs.wf.create_carddata import CreateCarddataWorkflowStatusItem
 from wcs.wf.create_formdata import CreateFormdataWorkflowStatusItem, Mapping
@@ -42,7 +42,7 @@ from wcs.formdef import FormDef
 from wcs import fields
 
 from utilities import get_app, login, create_temporary_pub, clean_temporary_pub
-from .test_all import create_superuser, create_role
+from .test_all import create_superuser
 
 
 def pytest_generate_tests(metafunc):
@@ -95,7 +95,6 @@ def test_workflows_default(pub):
 
 def test_workflows_new(pub):
     create_superuser(pub)
-    create_role()
     Workflow.wipe()
     app = login(get_app(pub))
     resp = app.get('/backoffice/workflows/')
@@ -141,7 +140,9 @@ def test_workflows_new(pub):
 
 def test_workflows_svg(pub):
     create_superuser(pub)
-    role = create_role()
+    pub.role_class.wipe()
+    role = pub.role_class(name='foobar')
+    role.store()
     Workflow.wipe()
 
     workflow = Workflow(name='foo')
@@ -367,8 +368,8 @@ def test_workflows_import_from_url(pub):
 def test_workflows_export_import_create_role(pub):
     create_superuser(pub)
 
-    Role.wipe()
-    role = Role()
+    pub.role_class.wipe()
+    role = pub.role_class()
     role.name = 'PLOP'
     role.store()
 
@@ -409,12 +410,12 @@ def test_workflows_export_import_create_role(pub):
     resp = resp.follow()
     assert 'This workflow has been successfully imported' in resp.text
     assert Workflow.get(3).name == 'Copy of foo (2)'
-    assert Role.count() == 1
-    assert Role.select()[0].name == 'PLOP'
-    assert Workflow.get(3).possible_status[0].items[0].by == [Role.select()[0].id]
+    assert pub.role_class.count() == 1
+    assert pub.role_class.select()[0].name == 'PLOP'
+    assert Workflow.get(3).possible_status[0].items[0].by == [pub.role_class.select()[0].id]
 
     # don't create role if they are managed by the identity provider
-    Role.wipe()
+    pub.role_class.wipe()
 
     pub.cfg['sp'] = {'idp-manage-roles': True}
     pub.write_cfg()
@@ -523,7 +524,9 @@ def test_workflows_check_available_actions(pub):
 
 def test_workflows_edit_dispatch_action(pub):
     create_superuser(pub)
-    role = create_role()
+    pub.role_class.wipe()
+    role = pub.role_class(name='foobar')
+    role.store()
     Workflow.wipe()
     workflow = Workflow(name='foo')
     workflow.add_status(name='baz')
@@ -560,7 +563,6 @@ def test_workflows_edit_dispatch_action(pub):
 
 def test_workflows_edit_dispatch_action_repeated_function(pub):
     create_superuser(pub)
-    create_role()
     Workflow.wipe()
     workflow = Workflow(name='foo')
     workflow.add_status(name='baz')
@@ -591,7 +593,6 @@ def test_workflows_edit_dispatch_action_repeated_function(pub):
 
 def test_workflows_edit_email_action(pub):
     create_superuser(pub)
-    create_role()
     Workflow.wipe()
     workflow = Workflow(name='foo')
     st1 = workflow.add_status(name='baz')
@@ -740,7 +741,6 @@ def test_workflows_edit_email_action(pub):
 
 def test_workflows_edit_jump_previous(pub):
     create_superuser(pub)
-    create_role()
     Workflow.wipe()
     workflow = Workflow(name='foo')
     st1 = workflow.add_status(name='baz')
@@ -792,7 +792,6 @@ def test_workflows_edit_jump_previous(pub):
 
 def test_workflows_edit_jump_timeout(pub):
     create_superuser(pub)
-    create_role()
     Workflow.wipe()
     workflow = Workflow(name='foo')
     st1 = workflow.add_status(name='baz')
@@ -832,7 +831,6 @@ def test_workflows_edit_jump_timeout(pub):
 
 def test_workflows_edit_sms_action(pub):
     create_superuser(pub)
-    create_role()
     Workflow.wipe()
     workflow = Workflow(name='foo')
     workflow.add_status(name='baz')
@@ -859,7 +857,6 @@ def test_workflows_edit_sms_action(pub):
 
 def test_workflows_edit_attachment_action(pub):
     create_superuser(pub)
-    create_role()
     Workflow.wipe()
     workflow = Workflow(name='foo')
     workflow.add_status(name='baz')
@@ -924,7 +921,6 @@ def test_workflows_edit_attachment_action(pub):
 
 def test_workflows_edit_display_form_action(pub):
     create_superuser(pub)
-    create_role()
     Workflow.wipe()
     workflow = Workflow(name='foo')
     workflow.add_status(name='baz')
@@ -969,7 +965,6 @@ def test_workflows_edit_display_form_action(pub):
 
 def test_workflows_edit_choice_action(pub):
     create_superuser(pub)
-    create_role()
     Workflow.wipe()
     workflow = Workflow(name='foo')
     workflow.add_status(name='baz')
@@ -1002,7 +997,6 @@ def test_workflows_edit_choice_action(pub):
 
 def test_workflows_edit_choice_action_functions_only(pub):
     create_superuser(pub)
-    create_role()
     Workflow.wipe()
     workflow = Workflow(name='foo')
     workflow.add_status(name='baz')
@@ -1033,7 +1027,6 @@ def test_workflows_edit_choice_action_functions_only(pub):
 
 def test_workflows_edit_choice_action_line_details(pub):
     create_superuser(pub)
-    create_role()
 
     Workflow.wipe()
     wf = Workflow(name='foo')
@@ -1136,7 +1129,6 @@ def test_workflows_edit_export_to_model_action(pub):
 
 def test_workflows_action_subpath(pub):
     create_superuser(pub)
-    create_role()
     Workflow.wipe()
     workflow = Workflow(name='foo')
     baz_status = workflow.add_status(name='baz')
@@ -1153,7 +1145,6 @@ def test_workflows_action_subpath(pub):
 
 def test_workflows_display_action_ezt_validation(pub):
     create_superuser(pub)
-    create_role()
     Workflow.wipe()
     workflow = Workflow(name='foo')
     baz_status = workflow.add_status(name='baz')
@@ -1191,7 +1182,6 @@ def test_workflows_display_action_ezt_validation(pub):
 
 def test_workflows_delete_action(pub):
     create_superuser(pub)
-    create_role()
     Workflow.wipe()
     workflow = Workflow(name='foo')
     workflow.add_status(name='baz')
@@ -1219,7 +1209,6 @@ def test_workflows_delete_action(pub):
 
 def test_workflows_variables(pub):
     create_superuser(pub)
-    create_role()
 
     Workflow.wipe()
     workflow = Workflow(name='foo')
@@ -1278,7 +1267,14 @@ def test_workflows_variables_edit(pub):
 
 
 def test_workflows_variables_edit_with_all_action_types(pub):
-    test_workflows_add_all_actions(pub)
+    create_superuser(pub)
+
+    Workflow.wipe()
+    workflow = Workflow(name='foo')
+    status = workflow.add_status(name='baz')
+    for item_class in item_classes:
+        status.append_item(item_class.key)
+    workflow.store()
 
     app = login(get_app(pub))
     resp = app.get('/backoffice/workflows/1/')
@@ -1320,7 +1316,6 @@ def test_workflows_variables_with_export_to_model_action(pub):
 
 def test_workflows_backoffice_fields(pub):
     create_superuser(pub)
-    create_role()
 
     Workflow.wipe()
     workflow = Workflow(name='foo')
@@ -1428,7 +1423,6 @@ def test_workflows_backoffice_fields(pub):
 
 def test_workflows_functions(pub):
     create_superuser(pub)
-    create_role()
 
     Workflow.wipe()
     workflow = Workflow(name='foo')
@@ -1484,7 +1478,6 @@ def test_workflows_functions(pub):
 
 def test_workflows_functions_vs_visibility(pub):
     create_superuser(pub)
-    create_role()
 
     Workflow.wipe()
     workflow = Workflow(name='foo')
@@ -1525,7 +1518,6 @@ def test_workflows_functions_vs_visibility(pub):
 
 def test_workflows_global_actions(pub):
     create_superuser(pub)
-    create_role()
 
     Workflow.wipe()
     workflow = Workflow(name='foo')
@@ -1573,7 +1565,6 @@ def test_workflows_global_actions(pub):
 
 def test_workflows_global_actions_edit(pub):
     create_superuser(pub)
-    create_role()
 
     Workflow.wipe()
     workflow = Workflow(name='foo')
@@ -1635,7 +1626,6 @@ def test_workflows_global_actions_edit(pub):
 
 def test_workflows_global_actions_timeout_triggers(pub):
     create_superuser(pub)
-    create_role()
 
     Workflow.wipe()
     workflow = Workflow(name='foo')
@@ -1687,7 +1677,6 @@ def test_workflows_global_actions_timeout_triggers(pub):
 
 def test_workflows_global_actions_webservice_trigger(pub):
     create_superuser(pub)
-    create_role()
 
     Workflow.wipe()
     workflow = Workflow(name='foo')
@@ -1825,7 +1814,6 @@ def test_workflows_external_workflow_action_config(pub):
 
 def test_workflows_create_formdata(pub):
     create_superuser(pub)
-    create_role()
 
     FormDef.wipe()
     target_formdef = FormDef()
@@ -2086,7 +2074,6 @@ def test_workflows_edit_carddata_action(pub):
 
 def test_workflows_criticality_levels(pub):
     create_superuser(pub)
-    create_role()
 
     Workflow.wipe()
     workflow = Workflow(name='foo')
@@ -2151,7 +2138,6 @@ def test_workflows_criticality_levels(pub):
 
 def test_workflows_wscall_label(pub):
     create_superuser(pub)
-    create_role()
 
     Workflow.wipe()
     workflow = Workflow(name='foo')
@@ -2175,7 +2161,6 @@ def test_workflows_wscall_label(pub):
 @pytest.mark.parametrize('value', [True, False])
 def test_workflows_wscall_options(pub, value):
     create_superuser(pub)
-    create_role()
 
     Workflow.wipe()
     workflow = Workflow(name='foo')
@@ -2280,7 +2265,9 @@ def test_workflows_form_action_config(pub):
 
 def test_workflows_inspect_view(pub):
     create_superuser(pub)
-    role = create_role()
+    pub.role_class.wipe()
+    role = pub.role_class(name='foobar')
+    role.store()
 
     Workflow.wipe()
     workflow = Workflow(name='foo')
diff --git a/tests/api/test_access.py b/tests/api/test_access.py
index 60550c44..fd0b32c9 100644
--- a/tests/api/test_access.py
+++ b/tests/api/test_access.py
@@ -17,7 +17,6 @@ from wcs.api_utils import get_secret_and_orig, is_url_signed, sign_url
 from wcs.qommon.errors import AccessForbiddenError
 from wcs.qommon.http_request import HTTPRequest
 from wcs.qommon.ident.password_accounts import PasswordAccount
-from wcs.roles import Role
 
 
 def pytest_generate_tests(metafunc):
@@ -269,8 +268,8 @@ def test_sign_url(pub, local_user):
 
 
 def test_get_user(pub, local_user):
-    Role.wipe()
-    role = Role(name='Foo bar')
+    pub.role_class.wipe()
+    role = pub.role_class(name='Foo bar')
     role.store()
     local_user.roles = [role.id]
     local_user.store()
@@ -294,8 +293,8 @@ def test_api_access_from_xml_storable_object(pub, local_user, admin_user):
     resp.form['access_key'] = '5678'
     resp = resp.form.submit('submit')
 
-    Role.wipe()
-    role = Role(name='Foo bar')
+    pub.role_class.wipe()
+    role = pub.role_class(name='Foo bar')
     role.store()
     local_user.roles = [role.id]
     local_user.store()
diff --git a/tests/api/test_carddef.py b/tests/api/test_carddef.py
index 1b530d4d..a9e55641 100644
--- a/tests/api/test_carddef.py
+++ b/tests/api/test_carddef.py
@@ -20,7 +20,6 @@ from wcs.categories import CardDefCategory
 from wcs.data_sources import NamedDataSource
 from wcs.qommon.form import PicklableUpload
 from wcs.qommon.http_request import HTTPRequest
-from wcs.roles import Role
 from wcs.workflows import Workflow, WorkflowBackofficeFieldsFormDef
 
 from .utils import sign_uri
@@ -67,8 +66,8 @@ def local_user():
 
 
 def test_cards(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
     local_user.roles = [role.id]
     local_user.store()
@@ -164,8 +163,8 @@ def test_cards(pub, local_user):
 
 
 def test_cards_import_csv(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
     local_user.roles = [role.id]
     local_user.store()
@@ -204,8 +203,8 @@ def test_post_invalid_json(pub, local_user):
 
 
 def test_card_submit(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
     local_user.roles = [role.id]
     local_user.store()
@@ -277,8 +276,8 @@ def test_carddef_submit_with_varname(pub, local_user):
     data_source.data_source = {'type': 'formula', 'value': 'http://example.com/jsonp'}
     data_source.store()
 
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
     local_user.roles = [role.id]
     local_user.store()
@@ -369,8 +368,8 @@ def test_carddef_submit_from_wscall(pub, local_user):
     data_source.data_source = {'type': 'formula', 'value': 'http://example.com/jsonp'}
     data_source.store()
 
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
     local_user.roles = [role.id]
     local_user.store()
@@ -482,8 +481,8 @@ def test_carddef_submit_from_wscall(pub, local_user):
 
 
 def test_formdef_submit_structured(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
     local_user.roles = [role.id]
     local_user.store()
diff --git a/tests/api/test_category.py b/tests/api/test_category.py
index 4393efc7..00d7b4df 100644
--- a/tests/api/test_category.py
+++ b/tests/api/test_category.py
@@ -9,7 +9,6 @@ from utilities import clean_temporary_pub, create_temporary_pub, get_app
 from wcs.categories import Category
 from wcs.formdef import FormDef
 from wcs.qommon.http_request import HTTPRequest
-from wcs.roles import Role
 
 from .utils import sign_uri
 
@@ -205,8 +204,8 @@ def test_categories_formdefs(pub, local_user):
     assert resp.json['err'] == 0
     assert len(resp.json['data']) == 0
 
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
     local_user.roles = []
     local_user.store()
diff --git a/tests/api/test_custom_view.py b/tests/api/test_custom_view.py
index 4e174d39..1dc91fa1 100644
--- a/tests/api/test_custom_view.py
+++ b/tests/api/test_custom_view.py
@@ -14,7 +14,6 @@ from wcs.carddef import CardDef
 from wcs.formdef import FormDef
 from wcs.qommon import ods
 from wcs.qommon.http_request import HTTPRequest
-from wcs.roles import Role
 
 from .utils import sign_uri
 
@@ -61,8 +60,8 @@ def local_user():
 
 @pytest.fixture
 def test_api_custom_view_access(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
     local_user.roles = [role.id]
     local_user.store()
@@ -163,8 +162,8 @@ def test_api_custom_view_access(pub, local_user):
 
 
 def test_api_list_formdata_custom_view(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
 
     FormDef.wipe()
@@ -212,8 +211,8 @@ def test_api_list_formdata_custom_view(pub, local_user):
 
 
 def test_api_ods_formdata_custom_view(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
 
     FormDef.wipe()
@@ -265,8 +264,8 @@ def test_api_ods_formdata_custom_view(pub, local_user):
 
 
 def test_api_geojson_formdata_custom_view(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
 
     FormDef.wipe()
diff --git a/tests/api/test_formdata.py b/tests/api/test_formdata.py
index 726b6c41..c125d824 100644
--- a/tests/api/test_formdata.py
+++ b/tests/api/test_formdata.py
@@ -23,7 +23,6 @@ from wcs.qommon import ods
 from wcs.qommon.form import PicklableUpload
 from wcs.qommon.http_request import HTTPRequest
 from wcs.qommon.ident.password_accounts import PasswordAccount
-from wcs.roles import Role
 from wcs.workflows import EditableWorkflowStatusItem, Workflow, WorkflowBackofficeFieldsFormDef
 
 from .utils import sign_uri
@@ -89,8 +88,8 @@ def admin_user():
 
 @pytest.fixture
 def ics_data(local_user):
-    Role.wipe()
-    role = Role(name='test')
+    get_publisher().role_class.wipe()
+    role = get_publisher().role_class(name='test')
     role.store()
 
     FormDef.wipe()
@@ -150,11 +149,11 @@ def test_formdata(pub, local_user):
     ]
     block.store()
 
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.id = '123'
     role.store()
-    another_role = Role(name='another')
+    another_role = pub.role_class(name='another')
     another_role.id = '321'
     another_role.store()
     FormDef.wipe()
@@ -280,11 +279,11 @@ def test_formdata_backoffice_fields(pub, local_user):
 
 
 def test_formdata_duplicated_varnames(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.id = '123'
     role.store()
-    another_role = Role(name='another')
+    another_role = pub.role_class(name='another')
     another_role.id = '321'
     another_role.store()
     FormDef.wipe()
@@ -338,11 +337,11 @@ def test_formdata_duplicated_varnames(pub, local_user):
 
 
 def test_formdata_edit(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.id = '123'
     role.store()
-    another_role = Role(name='another')
+    another_role = pub.role_class(name='another')
     another_role.id = '321'
     another_role.store()
     local_user.roles = [role.id]
@@ -422,8 +421,8 @@ def test_formdata_edit(pub, local_user):
 
 
 def test_formdata_with_workflow_data(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.id = '123'
     role.store()
 
@@ -465,8 +464,8 @@ def test_formdata_with_workflow_data(pub, local_user):
 
 
 def test_api_list_formdata(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
 
     FormDef.wipe()
@@ -629,8 +628,8 @@ def test_api_list_formdata(pub, local_user):
 
 
 def test_api_anonymized_formdata(pub, local_user, admin_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
 
     FormDef.wipe()
@@ -734,8 +733,8 @@ def test_api_anonymized_formdata(pub, local_user, admin_user):
 
 
 def test_api_geojson_formdata(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
 
     FormDef.wipe()
@@ -848,8 +847,8 @@ def test_api_geojson_formdata(pub, local_user):
 
 
 def test_api_ods_formdata(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
 
     FormDef.wipe()
@@ -906,8 +905,8 @@ def test_api_ods_formdata(pub, local_user):
 
 
 def test_api_global_geojson(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
 
     FormDef.wipe()
@@ -965,8 +964,8 @@ def test_api_global_listing(pub, local_user):
         pytest.skip('this requires SQL')
         return
 
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
 
     # check there's no crash if there are no formdefs
@@ -1039,7 +1038,7 @@ def test_api_global_listing(pub, local_user):
 def test_api_global_listing_ignored_roles(pub, local_user):
     test_api_global_listing(pub, local_user)
 
-    role = Role(name='test2')
+    role = pub.role_class(name='test2')
     role.store()
 
     formdef = FormDef()
@@ -1082,8 +1081,8 @@ def test_api_include_anonymised(pub, local_user):
         pytest.skip('this requires SQL')
         return
 
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
 
     # add proper role to user
@@ -1124,7 +1123,7 @@ def test_api_include_anonymised(pub, local_user):
 
 
 def test_api_ics_formdata(pub, local_user, ics_data):
-    role = Role.select()[0]
+    role = pub.role_class.select()[0]
 
     # check access is denied if the user has not the appropriate role
     resp = get_app(pub).get(sign_uri('/api/forms/test/ics/foobar', user=local_user), status=403)
@@ -1189,7 +1188,7 @@ def test_api_ics_formdata(pub, local_user, ics_data):
 
 
 def test_api_ics_formdata_http_auth(pub, local_user, admin_user, ics_data):
-    role = Role.select()[0]
+    role = pub.role_class.select()[0]
 
     # check as admin
     app = login(get_app(pub))
@@ -1232,7 +1231,7 @@ def test_api_ics_formdata_http_auth(pub, local_user, admin_user, ics_data):
 
 
 def test_api_ics_formdata_custom_view(pub, local_user, ics_data):
-    role = Role.select()[0]
+    role = pub.role_class.select()[0]
 
     formdef = FormDef.get_by_urlname('test')
 
diff --git a/tests/api/test_formdef.py b/tests/api/test_formdef.py
index 64ed8ca4..3490c29b 100644
--- a/tests/api/test_formdef.py
+++ b/tests/api/test_formdef.py
@@ -20,7 +20,6 @@ from wcs.data_sources import NamedDataSource
 from wcs.formdef import FormDef
 from wcs.qommon.form import PicklableUpload
 from wcs.qommon.http_request import HTTPRequest
-from wcs.roles import Role
 from wcs.wf.jump import JumpWorkflowStatusItem
 from wcs.workflows import Workflow, WorkflowBackofficeFieldsFormDef
 
@@ -68,8 +67,8 @@ def local_user():
 
 
 def test_formdef_list(pub):
-    Role.wipe()
-    role = Role(name='Foo bar')
+    pub.role_class.wipe()
+    role = pub.role_class(name='Foo bar')
     role.id = '14'
     role.store()
 
@@ -149,8 +148,8 @@ def test_formdef_list(pub):
 
 
 def test_limited_formdef_list(pub, local_user):
-    Role.wipe()
-    role = Role(name='Foo bar')
+    pub.role_class.wipe()
+    role = pub.role_class(name='Foo bar')
     role.id = '14'
     role.store()
 
@@ -239,8 +238,8 @@ def test_formdef_list_redirection(pub):
 
 
 def test_backoffice_submission_formdef_list(pub, local_user):
-    Role.wipe()
-    role = Role(name='Foo bar')
+    pub.role_class.wipe()
+    role = pub.role_class(name='Foo bar')
     role.id = '14'
     role.store()
 
@@ -445,8 +444,8 @@ def test_post_invalid_json(pub, local_user):
 
 
 def test_formdef_submit(pub, local_user):
-    Role.wipe()
-    role = Role(name='test')
+    pub.role_class.wipe()
+    role = pub.role_class(name='test')
     role.store()
     local_user.roles = [role.id]
     local_user.store()
diff --git a/tests/api/test_user.py b/tests/api/test_user.py
index c08428de..e418ee0c 100644
--- a/tests/api/test_user.py
+++ b/tests/api/test_user.py
@@ -12,7 +12,6 @@ from wcs.formdef import FormDef
 from wcs.qommon.form import PicklableUpload
 from wcs.qommon.http_request import HTTPRequest
 from wcs.qommon.ident.password_accounts import PasswordAccount
-from wcs.roles import Role
 from wcs.workflows import Workflow, WorkflowVariablesFieldsFormDef
 
 from .utils import sign_uri
@@ -77,8 +76,8 @@ def admin_user():
 
 
 def test_roles(pub, local_user):
-    Role.wipe()
-    role = Role(name='Hello World')
+    pub.role_class.wipe()
+    role = pub.role_class(name='Hello World')
     role.emails = ['toto@example.com', 'zozo@example.com']
     role.details = 'kouign amann'
     role.store()
@@ -109,7 +108,7 @@ def test_users(pub, local_user):
     assert resp.json['data'][0]['user_email'] == local_user.email
     assert resp.json['data'][0]['user_id'] == local_user.id
 
-    role = Role(name='Foo bar')
+    role = pub.role_class(name='Foo bar')
     role.store()
     local_user.roles = [role.id]
     local_user.store()
@@ -165,7 +164,7 @@ def test_user_by_nameid(pub, local_user):
 def test_user_roles(pub, local_user):
     local_user.name_identifiers = ['xyz']
     local_user.store()
-    role = Role(name='Foo bar')
+    role = pub.role_class(name='Foo bar')
     role.store()
     local_user.roles = [role.id]
     local_user.store()
@@ -339,8 +338,8 @@ def test_user_forms_limit_offset(pub, local_user):
 
 
 def test_user_forms_from_agent(pub, local_user):
-    Role.wipe()
-    role = Role(name='Foo bar')
+    pub.role_class.wipe()
+    role = pub.role_class(name='Foo bar')
     role.store()
 
     agent_user = get_publisher().user_class()
diff --git a/tests/api/test_workflow.py b/tests/api/test_workflow.py
index ed8eccd0..f431747b 100644
--- a/tests/api/test_workflow.py
+++ b/tests/api/test_workflow.py
@@ -10,7 +10,6 @@ from wcs import fields
 from wcs.formdef import FormDef
 from wcs.qommon.http_request import HTTPRequest
 from wcs.qommon.ident.password_accounts import PasswordAccount
-from wcs.roles import Role
 from wcs.wf.jump import JumpWorkflowStatusItem
 from wcs.wf.register_comment import RegisterCommenterWorkflowStatusItem
 from wcs.workflows import Workflow
@@ -108,8 +107,8 @@ def test_workflow_trigger(pub, local_user):
     get_app(pub).post(sign_uri(formdata.get_url() + 'jump/trigger/XXX/'), status=200)
     assert formdef.data_class().get(formdata.id).status == 'wf-st2'
 
-    Role.wipe()
-    role = Role(name='xxx')
+    pub.role_class.wipe()
+    role = pub.role_class(name='xxx')
     role.store()
 
     jump.by = [role.id]
@@ -318,8 +317,8 @@ def test_workflow_global_webservice_trigger(pub, local_user):
     add_to_journal.comment = 'HELLO WORLD 4'
     trigger.roles = ['logged-users']
     workflow.store()
-    Role.wipe()
-    role = Role(name='xxx')
+    pub.role_class.wipe()
+    role = pub.role_class(name='xxx')
     role.store()
     trigger.roles = [role.id]
     workflow.store()
